/* 2018-06-19: File changed by Sony Corporation */
/*
 * Copyright (c) 2016-2017, NVIDIA CORPORATION.
 *
 * SPDX-License-Identifier: GPL-2.0+
 */

#include <common.h>
#include <asm/arch/tegra.h>
#include <asm/arch-tegra/mmc.h>
#include <asm/arch-tegra/tegra_mmc.h>

DECLARE_GLOBAL_DATA_PTR;

int board_early_init_f(void)
{
	return 0;
}

__weak int tegra_board_init(void)
{
	return 0;
}

int board_init(void)
{
	return tegra_board_init();
}

__weak int cboot_init_late(void)
{
	return 0;
}

int board_late_init(void)
{
	return cboot_init_late();
}

void pad_init_mmc(struct mmc_host *host)
{
}

int board_mmc_init(bd_t *bd)
{
	tegra_mmc_init();

	return 0;
}

#ifdef CONFIG_ENV_GPT_PART_NAME
int mmc_get_env_addr(struct mmc *mmc, int copy, u64 *env_addr)
{
	s64 offset;

	disk_partition_t info;
	ulong start_addr, end_addr, part_size;
	struct blk_desc *desc = mmc_get_blk_desc(mmc);

	if (!desc || desc->type == DEV_TYPE_UNKNOWN) {
		printf("MMC partition type is unknown\n");
		return 1;
	}

	if (part_get_info_efi_by_name(desc, CONFIG_ENV_GPT_PART_NAME, &info)) {
		printf("Get environment variables from parition \"%s\" failed\n",
			CONFIG_ENV_GPT_PART_NAME);
		return 1;
	}

	start_addr = info.start * info.blksz;
	part_size = info.size * info.blksz;
	end_addr = start_addr + part_size;
#ifdef CONFIG_ENV_OFFSET_REDUND
	if (CONFIG_ENV_SIZE * 2 > part_size) {
#else
	if (CONFIG_ENV_SIZE > part_size) {
#endif
		printf("The partition size is less than env size\n");
		return 1;
	}

	offset = CONFIG_ENV_OFFSET;
#ifdef CONFIG_ENV_OFFSET_REDUND
	if (copy)
		offset = CONFIG_ENV_OFFSET_REDUND;
#endif

	if (offset < 0) {
		offset += end_addr;
		if (offset < start_addr) {
			printf("The env offset is overflow\n");
			return 1;
		}
	} else {
		offset += start_addr;
		if (offset + CONFIG_ENV_SIZE > end_addr) {
			printf("The env offset is overflow\n");
			return 1;
		}
	}

	*env_addr = offset;

	return 0;
}
#endif
